diff --git a/gcc/config/bpf/bpf.c b/gcc/config/bpf/bpf.c
index 36e08338630..84d17d4a27f 100644
--- a/gcc/config/bpf/bpf.c
+++ b/gcc/config/bpf/bpf.c
@@ -66,6 +66,63 @@ struct GTY(()) machine_function
   int callee_saved_reg_size;
 };
 
+/* Handle an attribute requiring a FUNCTION_DECL;
+   arguments as in struct attribute_spec.handler.  */
+
+static tree
+bpf_handle_fndecl_attribute (tree *node, tree name,
+			     tree args,
+			     int flags ATTRIBUTE_UNUSED,
+			     bool *no_add_attrs)
+{
+  if (TREE_CODE (*node) != FUNCTION_DECL)
+    {
+      warning (OPT_Wattributes, "%qE attribute only applies to functions",
+	       name);
+      *no_add_attrs = true;
+    }
+
+  if (is_attribute_p ("kernel_helper", name))
+    {
+      if (args)
+	{
+	  tree cst = TREE_VALUE (args);
+	  if (TREE_CODE (cst) != INTEGER_CST)
+	    {
+	      warning (OPT_Wattributes, "%qE attribute requires an integer argument",
+		       name);
+	      *no_add_attrs = true;
+	    }
+	}
+      else
+	{
+	  warning (OPT_Wattributes, "%qE requires an argument", name);
+	  *no_add_attrs = true;
+	}
+    }
+
+  return NULL_TREE;
+}
+
+/* Target-specific attributes.  */
+
+static const struct attribute_spec bpf_attribute_table[] =
+{
+  /* Syntax: { name, min_len, max_len, decl_required, type_required,
+	       function_type_required, affects_type_identity, handler,
+	       exclude } */
+
+ /* Attribute to mark function prototypes as kernel helpers.  */
+ { "kernel_helper", 1, 1, true, false, false, false,
+   bpf_handle_fndecl_attribute, NULL },
+
+ /* The last attribute spec is set to be NULL.  */
+ { NULL,	0,  0, false, false, false, false, NULL, NULL }
+};
+
+#undef TARGET_ATTRIBUTE_TABLE
+#define TARGET_ATTRIBUTE_TABLE bpf_attribute_table
+
 /* Data structures for the eBPF specific built-ins.  */
 
 /* Maximum number of arguments taken by a builtin function, plus
@@ -75,47 +132,13 @@ struct GTY(()) machine_function
 enum bpf_builtins
 {
   BPF_BUILTIN_UNUSED = 0,
-  /* Built-ins for kernel helpers.  */
-#define DEF_HELPER(V,D,N,T) BPF_BUILTIN_HELPER_##D,
-#  include "bpf-helpers.def"
-#undef DEF_HELPER
-  BPF_BUILTIN_HELPER_MAX,
   /* Built-ins for non-generic loads and stores.  */
-  BPF_BUILTIN_LOAD_BYTE = BPF_BUILTIN_HELPER_MAX,
+  BPF_BUILTIN_LOAD_BYTE,
   BPF_BUILTIN_LOAD_HALF,
   BPF_BUILTIN_LOAD_WORD,
   BPF_BUILTIN_MAX,
 };
 
-/* This table is indexed by an enum bpf_builtin.  */
-static const char *bpf_helper_names[] =
-{
-  NULL,
-#define DEF_HELPER(V,D,N,T) #N,
-#  include "bpf-helpers.def"
-#undef DEF_HELPER
-  NULL,
-  NULL,
-  NULL,
-  NULL
-};
-
-/* Return the builtin code corresponding to the kernel helper builtin
-   __builtin_NAME, or 0 if the name doesn't correspond to a kernel
-   helper builtin.  */
-
-static inline int
-bpf_helper_code (const char *name)
-{
-  int i;
-
-  for (i = 1; i < BPF_BUILTIN_HELPER_MAX; ++i)
-    if (strcmp (name, bpf_helper_names[i]) == 0)
-      return i;
-
-  return 0;
-}
-
 static GTY (()) tree bpf_builtins[(int) BPF_BUILTIN_MAX];
 
 /* Initialize the per-function machine status.  */
@@ -149,7 +172,7 @@ void
 bpf_target_macros (cpp_reader *pfile)
 {
   builtin_define ("__BPF__");
-  
+
   if (TARGET_BIG_ENDIAN)
     builtin_define ("__BPF_BIG_ENDIAN__");
   else
@@ -187,7 +210,7 @@ bpf_target_macros (cpp_reader *pfile)
       case LINUX_V5_1: version_code = "0x50100"; break;
       case LINUX_V5_2: version_code = "0x50200"; break;
       default:
-	gcc_unreachable ();      
+	gcc_unreachable ();
       }
 
     kernel_version_code = ACONCAT (("__BPF_KERNEL_VERSION_CODE__=",
@@ -359,7 +382,7 @@ bpf_expand_prologue (void)
       insn = emit_move_insn (stack_pointer_rtx,
 			     hard_frame_pointer_rtx);
       RTX_FRAME_RELATED_P (insn) = 1;
-      
+
       if (size > 0)
 	{
 	  insn = emit_insn (gen_rtx_SET (stack_pointer_rtx,
@@ -528,7 +551,7 @@ bpf_legitimate_address_p (machine_mode mode ATTRIBUTE_UNUSED,
 
 	rtx x0 = XEXP (x, 0);
 	rtx x1 = XEXP (x, 1);
-	
+
 	if (bpf_address_base_p (x0, strict) && GET_CODE (x1) == CONST_INT)
 	  return IN_RANGE (INTVAL (x1), -1 - 0x7fff, 0x7fff);
 
@@ -681,13 +704,16 @@ bpf_output_call (rtx target)
       break;
     case SYMBOL_REF:
       {
-	const char *function_name = XSTR (target, 0);
-	int code;
-      
-	if (strncmp (function_name, "__builtin_bpf_helper_", 21) == 0
-	    && ((code = bpf_helper_code (function_name + 21)) != 0))
+	tree decl = SYMBOL_REF_DECL (target);
+	tree attr;
+
+	if (decl
+	    && (attr = lookup_attribute ("kernel_helper",
+					 DECL_ATTRIBUTES (decl))))
 	  {
-	    xops[0] = GEN_INT (code);
+	    tree attr_args = TREE_VALUE (attr);
+
+	    xops[0] = GEN_INT (TREE_INT_CST_LOW (TREE_VALUE (attr_args)));
 	    output_asm_insn ("call\t%0", xops);
 	  }
 	else
@@ -792,40 +818,7 @@ def_builtin (const char *name, enum bpf_builtins code, tree type)
 static void
 bpf_init_builtins (void)
 {
-  /* Built-ins for calling kernel helpers.  */
-
-  tree pt = build_pointer_type (void_type_node);
-  tree const_void_type
-    = build_qualified_type (void_type_node, TYPE_QUAL_CONST);
-  tree cpt = build_pointer_type (const_void_type);
-  tree st = short_integer_type_node;
-  tree ust = uint16_type_node;
-  tree it = integer_type_node;
-  tree ut = unsigned_type_node;
-  tree const_char_type
-    = build_qualified_type (char_type_node, TYPE_QUAL_CONST);
-  tree cst = build_pointer_type (const_char_type);
-  tree vt = void_type_node;
-  tree ult = long_unsigned_type_node;
-  tree u32t = uint32_type_node;
-  tree u64t = uint64_type_node;
-  tree llt = long_long_integer_type_node;
   tree ullt = long_long_unsigned_type_node;
-  
-#define TYPES build_function_type_list
-#define VTYPES build_varargs_function_type_list
-#define DEF_HELPER(V,D,N,T)				\
-  do							\
-    {							\
-      if (bpf_kernel >= (V))				\
-	def_builtin ("__builtin_bpf_helper_" #N,	\
-		     BPF_BUILTIN_HELPER_##D,		\
-		     T);				\
-    } while (0);
-#  include "bpf-helpers.def"
-#undef TYPES
-#undef VTYPES
-#undef DEF_HELPER
 
   /* Built-ins for BPF_LD_ABS and BPF_LD_IND instructions.  */
 
@@ -844,30 +837,17 @@ bpf_init_builtins (void)
    with bpf_init_builtins.  */
 
 static rtx
-bpf_expand_builtin (tree exp, rtx target,
+bpf_expand_builtin (tree exp, rtx target ATTRIBUTE_UNUSED,
 		    rtx subtarget ATTRIBUTE_UNUSED,
 		    machine_mode mode ATTRIBUTE_UNUSED,
-		    int ignore)
+		    int ignore ATTRIBUTE_UNUSED)
 {
   tree fndecl = TREE_OPERAND (CALL_EXPR_FN (exp), 0);
   int code = DECL_MD_FUNCTION_CODE (fndecl);
 
-  if (code >= 1 && code < BPF_BUILTIN_HELPER_MAX)
-    {
-      /* This is a builtin to call a kernel helper function.
-
-	 For these builtins, we just expand the function call normally
-	 with expand_call like we would do for a libcall. The function
-	 bpf_output_call below will then do The Right Thing (TM),
-	 recognizing the name of the called __builtin_helper_* symbol
-	 and emitting the corresponding CALL N instruction whenever
-	 necessary.  */
-
-      return expand_call (exp, target, ignore);
-    }
-  else if (code == BPF_BUILTIN_LOAD_BYTE
-	   || code == BPF_BUILTIN_LOAD_HALF
-	   || code == BPF_BUILTIN_LOAD_WORD)
+  if (code == BPF_BUILTIN_LOAD_BYTE
+      || code == BPF_BUILTIN_LOAD_HALF
+      || code == BPF_BUILTIN_LOAD_WORD)
     {
       /* Expand an indirect load from the sk_buff in the context.
 	 There is just one argument to the builtin, which is the
diff --git a/gcc/testsuite/gcc.target/bpf/helper-bind.c b/gcc/testsuite/gcc.target/bpf/helper-bind.c
index 2d1fedc4ce8..8dfde242a23 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-bind.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-bind.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   void *ctx, *addr;
   int addr_len;
 
-  ret = __builtin_bpf_helper_bind (ctx, addr, addr_len);
+  ret = bpf_bind (ctx, addr, addr_len);
 }
 
 /* { dg-final { scan-assembler "call\t64" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-bpf-redirect.c b/gcc/testsuite/gcc.target/bpf/helper-bpf-redirect.c
index 844c88d3e34..9937d5ab4cc 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-bpf-redirect.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-bpf-redirect.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   uint32_t ifindex;
   uint64_t flags;
 
-  ret = __builtin_bpf_helper_redirect (ifindex, flags);
+  ret = bpf_redirect (ifindex, flags);
 }
 
 /* { dg-final { scan-assembler "call\t23" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-clone-redirect.c b/gcc/testsuite/gcc.target/bpf/helper-clone-redirect.c
index a4fb8139234..e38adbc40e7 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-clone-redirect.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-clone-redirect.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -10,7 +12,7 @@ foo ()
   uint32_t ifindex;
   uint64_t flags;
 
-  ret = __builtin_bpf_helper_clone_redirect (skb, ifindex, flags);
+  ret = bpf_clone_redirect (skb, ifindex, flags);
 }
 
 /* { dg-final { scan-assembler "call\t13" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-csum-diff.c b/gcc/testsuite/gcc.target/bpf/helper-csum-diff.c
index ef38192efd3..a1c8bf5a026 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-csum-diff.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-csum-diff.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -10,7 +12,7 @@ foo ()
   uint64_t to_size, from_size;
   int seed;
 
-  ret = __builtin_bpf_helper_csum_diff (from, from_size, to, to_size, seed);
+  ret = bpf_csum_diff (from, from_size, to, to_size, seed);
 }
 
 /* { dg-final { scan-assembler "call\t28" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-csum-update.c b/gcc/testsuite/gcc.target/bpf/helper-csum-update.c
index 3cde8678cb5..4f65033acb4 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-csum-update.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-csum-update.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   void *skb;
   int csum;
 
-  ret = __builtin_bpf_helper_csum_update (skb, csum);
+  ret = bpf_csum_update (skb, csum);
 }
 
 /* { dg-final { scan-assembler "call\t40" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-current-task-under-cgroup.c b/gcc/testsuite/gcc.target/bpf/helper-current-task-under-cgroup.c
index a7eb6e617e8..5b05378a730 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-current-task-under-cgroup.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-current-task-under-cgroup.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   void *map;
   uint32_t index;
 
-  ret = __builtin_bpf_helper_current_task_under_cgroup (map, index);
+  ret = bpf_current_task_under_cgroup (map, index);
 }
 
 /* { dg-final { scan-assembler "call\t37" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-fib-lookup.c b/gcc/testsuite/gcc.target/bpf/helper-fib-lookup.c
index 9a9f79d402c..8290234108a 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-fib-lookup.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-fib-lookup.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -10,7 +12,7 @@ foo ()
   int plen;
   uint32_t flags;
 
-  ret = __builtin_bpf_helper_fib_lookup (ctx, params, plen, flags);
+  ret = bpf_fib_lookup (ctx, params, plen, flags);
 }
 
 /* { dg-final { scan-assembler "call\t69" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-cgroup-classid.c b/gcc/testsuite/gcc.target/bpf/helper-get-cgroup-classid.c
index 6cfd14d0ad1..5d85a89c632 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-cgroup-classid.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-cgroup-classid.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -8,7 +10,7 @@ foo ()
   uint32_t ret;
   void *skb;
 
-  ret = __builtin_bpf_helper_get_cgroup_classid (skb);
+  ret = bpf_get_cgroup_classid (skb);
 }
 
 /* { dg-final { scan-assembler "call\t17" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-current-cgroup-id.c b/gcc/testsuite/gcc.target/bpf/helper-get-current-cgroup-id.c
index 916dc4d3bb1..b0c0b74c11f 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-current-cgroup-id.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-current-cgroup-id.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   uint64_t ret;
   
-  ret = __builtin_bpf_helper_get_current_cgroup_id ();
+  ret = bpf_get_current_cgroup_id ();
 }
 
 /* { dg-final { scan-assembler "call\t80" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-current-comm.c b/gcc/testsuite/gcc.target/bpf/helper-get-current-comm.c
index efc330c3c98..1e25cd1cc7e 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-current-comm.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-current-comm.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   void *buf;
   uint32_t size_of_buf;
 
-  ret = __builtin_bpf_helper_get_current_comm (buf, size_of_buf);
+  ret = bpf_get_current_comm (buf, size_of_buf);
 }
 
 /* { dg-final { scan-assembler "call\t16" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-current-pid-tgid.c b/gcc/testsuite/gcc.target/bpf/helper-get-current-pid-tgid.c
index 32d3e9c91d1..1dd7a1e507b 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-current-pid-tgid.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-current-pid-tgid.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   uint64_t ret;
 
-  ret = __builtin_bpf_helper_get_current_pid_tgid ();
+  ret = bpf_get_current_pid_tgid ();
 }
 
 /* { dg-final { scan-assembler "call\t14" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-current-task.c b/gcc/testsuite/gcc.target/bpf/helper-get-current-task.c
index 016c134b132..79344d15abf 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-current-task.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-current-task.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   uint64_t ret;
 
-  ret = __builtin_bpf_helper_get_current_task ();
+  ret = bpf_get_current_task ();
 }
 
 /* { dg-final { scan-assembler "call\t35" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-current-uid-gid.c b/gcc/testsuite/gcc.target/bpf/helper-get-current-uid-gid.c
index 1dc2f9f41e5..b3e7261c35b 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-current-uid-gid.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-current-uid-gid.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   uint64_t ret;
 
-  ret = __builtin_bpf_helper_get_current_uid_gid ();
+  ret = bpf_get_current_uid_gid ();
 }
 
 /* { dg-final { scan-assembler "call\t15" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-hash-recalc.c b/gcc/testsuite/gcc.target/bpf/helper-get-hash-recalc.c
index 1db5d871c26..e9d87ae9bcc 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-hash-recalc.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-hash-recalc.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -8,7 +10,7 @@ foo ()
   uint32_t ret;
   void *skb;
 
-  ret = __builtin_bpf_helper_get_hash_recalc (skb);
+  ret = bpf_get_hash_recalc (skb);
 }
 
 /* { dg-final { scan-assembler "call\t34" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-listener-sock.c b/gcc/testsuite/gcc.target/bpf/helper-get-listener-sock.c
index 298da1c949b..500ba787a3a 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-listener-sock.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-listener-sock.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   void *ret, *sk;
 
-  ret = __builtin_bpf_helper_get_listener_sock (sk);
+  ret = bpf_get_listener_sock (sk);
 }
 
 /* { dg-final { scan-assembler "call\t98" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-local-storage.c b/gcc/testsuite/gcc.target/bpf/helper-get-local-storage.c
index 88da67e99ae..1c28ef52c11 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-local-storage.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-local-storage.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -8,7 +10,7 @@ foo ()
   void *ret, *map;
   uint64_t flags;
   
-  ret = __builtin_bpf_helper_get_local_storage (map, flags);
+  ret = bpf_get_local_storage (map, flags);
 }
 
 /* { dg-final { scan-assembler "call\t81" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-numa-node-id.c b/gcc/testsuite/gcc.target/bpf/helper-get-numa-node-id.c
index 628e1012152..e6477a5c1ff 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-numa-node-id.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-numa-node-id.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   int ret;
 
-  ret = __builtin_bpf_helper_get_numa_node_id ();
+  ret = bpf_get_numa_node_id ();
 }
 
 /* { dg-final { scan-assembler "call\t42" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-prandom-u32.c b/gcc/testsuite/gcc.target/bpf/helper-get-prandom-u32.c
index 6d3e5bc7a22..f30cafd36b0 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-prandom-u32.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-prandom-u32.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   uint32_t ret;
 
-  ret = __builtin_bpf_helper_get_prandom_u32 ();
+  ret = bpf_get_prandom_u32 ();
 }
 
 /* { dg-final { scan-assembler "call\t7" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-route-realm.c b/gcc/testsuite/gcc.target/bpf/helper-get-route-realm.c
index 5056c4adb1f..b7794307802 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-route-realm.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-route-realm.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -8,7 +10,7 @@ foo ()
   uint32_t ret;
   void *skb;
 
-  ret = __builtin_bpf_helper_get_route_realm (skb);
+  ret = bpf_get_route_realm (skb);
 }
 
 /* { dg-final { scan-assembler "call\t24" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-smp-processor-id.c b/gcc/testsuite/gcc.target/bpf/helper-get-smp-processor-id.c
index 655b87341df..7d0e9869826 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-smp-processor-id.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-smp-processor-id.c
@@ -1,13 +1,15 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   uint32_t ret;
 
-  ret = __builtin_bpf_helper_get_smp_processor_id ();
+  ret = bpf_get_smp_processor_id ();
 }
 
 /* { dg-final { scan-assembler "call\t8" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-socket-cookie.c b/gcc/testsuite/gcc.target/bpf/helper-get-socket-cookie.c
index afd17ddcd50..e2e421f9859 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-socket-cookie.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-socket-cookie.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -8,7 +10,7 @@ foo ()
   uint64_t ret;
   void *skb;
   
-  ret = __builtin_bpf_helper_get_socket_cookie (skb);
+  ret = bpf_get_socket_cookie (skb);
 }
 
 /* { dg-final { scan-assembler "call\t46" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-socket-uid.c b/gcc/testsuite/gcc.target/bpf/helper-get-socket-uid.c
index 3a274c965f7..343f86656d1 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-socket-uid.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-socket-uid.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -8,7 +10,7 @@ foo ()
   uint32_t ret;
   void *skb;
   
-  ret = __builtin_bpf_helper_get_socket_uid (skb);
+  ret = bpf_get_socket_uid (skb);
 }
 
 /* { dg-final { scan-assembler "call\t47" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-stack.c b/gcc/testsuite/gcc.target/bpf/helper-get-stack.c
index bbcdeb58775..cc3f6a06bb2 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-stack.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-stack.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -10,7 +12,7 @@ foo ()
   uint32_t size;
   uint64_t flags;
 
-  ret = __builtin_bpf_helper_get_stack (regs, buf, size, flags);
+  ret = bpf_get_stack (regs, buf, size, flags);
 }
 
 /* { dg-final { scan-assembler "call\t67" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-get-stackid.c b/gcc/testsuite/gcc.target/bpf/helper-get-stackid.c
index 319d15cd2fa..cc3ecb01a05 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-get-stackid.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-get-stackid.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   void *ctx, *map;
   uint64_t flags;
 
-  ret = __builtin_bpf_helper_get_stackid (ctx, map, flags);
+  ret = bpf_get_stackid (ctx, map, flags);
 }
 
 /* { dg-final { scan-assembler "call\t27" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-getsockopt.c b/gcc/testsuite/gcc.target/bpf/helper-getsockopt.c
index fb16f15e6ea..c4b32982ed7 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-getsockopt.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-getsockopt.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -10,8 +12,8 @@ foo ()
   int level, optname, optlen;
   char *optval;
   
-  ret = __builtin_bpf_helper_getsockopt (bpf_socket, level,
-					 optname, optval, optlen);
+  ret = bpf_getsockopt (bpf_socket, level,
+			optname, optval, optlen);
 }
 
 /* { dg-final { scan-assembler "call\t57" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-ktime-get-ns.c b/gcc/testsuite/gcc.target/bpf/helper-ktime-get-ns.c
index 405df057e30..77f1661f387 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-ktime-get-ns.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-ktime-get-ns.c
@@ -1,12 +1,14 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
 {
   uint64_t ret;
-  ret = __builtin_bpf_helper_ktime_get_ns ();
+  ret = bpf_ktime_get_ns ();
 }
 
 /* { dg-final { scan-assembler "call\t5" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-l3-csum-replace.c b/gcc/testsuite/gcc.target/bpf/helper-l3-csum-replace.c
index ac17662c5d6..c3f1b78397a 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-l3-csum-replace.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-l3-csum-replace.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -10,7 +12,7 @@ foo ()
   uint32_t offset;
   uint64_t from, to, size;
 
-  ret = __builtin_bpf_helper_l3_csum_replace (skb, offset, from, to, size);
+  ret = bpf_l3_csum_replace (skb, offset, from, to, size);
 }
 
 /* { dg-final { scan-assembler "call\t10" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-l4-csum-replace.c b/gcc/testsuite/gcc.target/bpf/helper-l4-csum-replace.c
index 52b5514b6cb..fd54f0b5e88 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-l4-csum-replace.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-l4-csum-replace.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -10,7 +12,7 @@ foo ()
   uint32_t offset;
   uint64_t from, to, size;
 
-  ret = __builtin_bpf_helper_l4_csum_replace (skb, offset, from, to, size);
+  ret = bpf_l4_csum_replace (skb, offset, from, to, size);
 }
 
 /* { dg-final { scan-assembler "call\t11" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-lwt-push-encap.c b/gcc/testsuite/gcc.target/bpf/helper-lwt-push-encap.c
index 1baed27fac7..c6d4769b742 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-lwt-push-encap.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-lwt-push-encap.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   void *skb, *hdr;
   uint32_t type, len;
   
-  ret = __builtin_bpf_helper_lwt_push_encap (skb, type, hdr, len);
+  ret = bpf_lwt_push_encap (skb, type, hdr, len);
 }
 
 /* { dg-final { scan-assembler "call\t73" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-action.c b/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-action.c
index ccc94c1af9d..4cd7052806b 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-action.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-action.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,8 +11,8 @@ foo ()
   void *skb, *param;
   uint32_t action, param_len;
   
-  ret = __builtin_bpf_helper_lwt_seg6_action (skb, action,
-					      param, param_len);
+  ret = bpf_lwt_seg6_action (skb, action,
+			     param, param_len);
 }
 
 /* { dg-final { scan-assembler "call\t76" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-adjust-srh.c b/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-adjust-srh.c
index 5e95124ad0f..adc8dc414df 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-adjust-srh.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-adjust-srh.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,7 +11,7 @@ foo ()
   void *skb;
   uint32_t offset, delta;
   
-  ret = __builtin_bpf_helper_lwt_seg6_adjust_srh (skb, offset,
+  ret = bpf_lwt_seg6_adjust_srh (skb, offset,
 						  delta);
 }
 
diff --git a/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-store-bytes.c b/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-store-bytes.c
index 098f97680f2..a35e917d575 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-store-bytes.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-lwt-seg6-store-bytes.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
 
 #include <stdint.h>
+#include <bpf-helpers.h>
 
 void
 foo ()
@@ -9,8 +11,7 @@ foo ()
   void *skb, *from;
   uint32_t offset, len;
   
-  ret = __builtin_bpf_helper_lwt_seg6_store_bytes (skb, offset,
-						   from, len);
+  ret = bpf_lwt_seg6_store_bytes (skb, offset, from, len);
 }
 
 /* { dg-final { scan-assembler "call\t74" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-map-delete-elem.c b/gcc/testsuite/gcc.target/bpf/helper-map-delete-elem.c
index b8a6cdec4ee..0200b15eb45 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-map-delete-elem.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-map-delete-elem.c
@@ -1,4 +1,7 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
+
+#include <bpf-helpers.h>
 
 char *map () { return 0; }
 
@@ -8,7 +11,7 @@ foo ()
   int ret;
   char *key = 0;
 
-  ret = __builtin_bpf_helper_map_delete_elem (map (), key);
+  ret = bpf_map_delete_elem (map (), key);
 }
 
 /* { dg-final { scan-assembler "call\t3" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-map-lookup-elem.c b/gcc/testsuite/gcc.target/bpf/helper-map-lookup-elem.c
index 839cfc423a7..1d443a05138 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-map-lookup-elem.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-map-lookup-elem.c
@@ -1,4 +1,7 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
+
+#include <bpf-helpers.h>
 
 char *map () { return 0; }
 
@@ -6,7 +9,7 @@ void
 foo ()
 {
   char *key = 0, *value = 0;
-  value = __builtin_bpf_helper_map_lookup_elem (map (), key);
+  value = bpf_map_lookup_elem (map (), key);
 }
 
 /* { dg-final { scan-assembler "call\t1" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-map-peek-elem.c b/gcc/testsuite/gcc.target/bpf/helper-map-peek-elem.c
index 6d0acb1dcb7..de833f202a9 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-map-peek-elem.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-map-peek-elem.c
@@ -1,4 +1,7 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
+
+#include <bpf-helpers.h>
 
 char *map () { return 0; }
 
@@ -8,7 +11,7 @@ foo ()
   int ret;
   char *value = 0;
 
-  ret = __builtin_bpf_helper_map_peek_elem (map (), value);
+  ret = bpf_map_peek_elem (map (), value);
 }
 
 /* { dg-final { scan-assembler "call\t89" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-map-pop-elem.c b/gcc/testsuite/gcc.target/bpf/helper-map-pop-elem.c
index 71a7851ca9c..7d76f853f38 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-map-pop-elem.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-map-pop-elem.c
@@ -1,4 +1,7 @@
 /* { dg-do compile } */
+/* { dg-options "-std=gnu99" } */
+
+#include <bpf-helpers.h>
 
 char *map () { return 0; }
 
@@ -8,7 +11,7 @@ foo ()
   int ret;
   char *value = 0;
 
-  ret = __builtin_bpf_helper_map_pop_elem (map (), value);
+  ret = bpf_map_pop_elem (map (), value);
 }
 
 /* { dg-final { scan-assembler "call\t88" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-map-push-elem.c b/gcc/testsuite/gcc.target/bpf/helper-map-push-elem.c
index 53bc0ac5dd7..b4b2a8ef1ef 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-map-push-elem.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-map-push-elem.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
 /* { dg-options "-std=gnu99" } */
 
+#include <bpf-helpers.h>
+
 char *map () { return 0; }
 
 void
@@ -10,7 +12,7 @@ foo ()
   char *value = 0;
   long long flags = 0;
 
-  ret = __builtin_bpf_helper_map_push_elem (map (), value, flags);
+  ret = bpf_map_push_elem (map (), value, flags);
 }
 
 /* { dg-final { scan-assembler "call\t87" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/helper-map-update-elem.c b/gcc/testsuite/gcc.target/bpf/helper-map-update-elem.c
index 6281442ba3d..6cceafe62e3 100644
--- a/gcc/testsuite/gcc.target/bpf/helper-map-update-elem.c
+++ b/gcc/testsuite/gcc.target/bpf/helper-map-update-elem.c
@@ -1,6 +1,8 @@
 /* { dg-do compile } */
 /* { dg-options "-std=gnu99" } */
 
+#include <bpf-helpers.h>
+
 char *map () { return 0; }
 
 void
@@ -10,7 +12,7 @@ foo ()
   long long flags = 0;
   char *key = 0, *value = 0;
 
-  ret = __builtin_bpf_helper_map_update_elem (map (), key, value, flags);
+  ret = bpf_map_update_elem (map (), key, value, flags);
 }
 
 /* { dg-final { scan-assembler "call\t2" } } */
